## digikam 7.1.0

=== CMakeLists.txt ===
#
# Copyright (c) 2010-2020, Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

set(CMAKE_MIN_VERSION   "3.3.2")
set(ECM_MIN_VERSION     "1.7.0")

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

execute_process(COMMAND ${CMAKE_COMMAND} --version OUTPUT_VARIABLE VERSION_CMAKE_INFO)
message(STATUS "CMake version: ${VERSION_CMAKE_INFO}")

# ==============================================================================
# Information to update before to release this package.

# digiKam version
set(DIGIKAM_MAJOR_VERSION "7")
set(DIGIKAM_MINOR_VERSION "1")
set(DIGIKAM_PATCH_VERSION "0")

# Suffix to add at end of version string. Usual values are:
# "-git"   : alpha code unstable from git. Do not use in production
# "-beta1" : beta1 release.
# "-beta2" : beta2 release.
# "-beta3" : beta3 release.
# "-rc"    : release candidate.
# ""       : final release. Can be used in production.
set(DIGIKAM_SUFFIX_VERSION "")

# ==============================================================================
# Set env. variables accordingly.

# NOTE: This string is used to set libdigikamcore and libdigikamdatabase SO version ID
set(DIGIKAM_VERSION_SHORT
    "${DIGIKAM_MAJOR_VERSION}.${DIGIKAM_MINOR_VERSION}.${DIGIKAM_PATCH_VERSION}"
)

set(DIGIKAM_VERSION_STRING
    "${DIGIKAM_VERSION_SHORT}${DIGIKAM_SUFFIX_VERSION}"
)

# Core Database XML version
# We must set this variable here at top level because it is used in both
# libs/database/core and data/database
# Version history:
# 1 : Original database XML file, published in production.
# 2 : 08-08-2014 : Fix Images.names field size (see bug #327646).
# 3 : 05/11/2015 : Add Face DB schema.
set(DBCORECONFIG_XML_VERSION "3")

# ==============================================================================

project(digikam
        VERSION ${DIGIKAM_VERSION_SHORT}
        LANGUAGES CXX C)

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Starting CMake configuration for ${PROJECT_NAME}")
message(STATUS "")

### ECM setup #########################################################################################################

find_package(ECM ${ECM_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/core/cmake/modules ${ECM_MODULE_PATH})

# Cmake macros
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)
include(CheckFunctionExists)
include(FeatureSummary)

# ECM macros
include(ECMOptionalAddSubdirectory)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)
include(ECMSetupVersion)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(ECMMarkAsTest)
include(ECMAddTests)

# KDE macros
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDEFrameworkCompilerSettings)
include(KDECompilerSettings)

# Local macros
include(MacroUtils)
include(MacroCompiler)
include(MacroOpenCV)
include(MacroJPEG)
include(MacroBoolTo01)

#######################################################################################################################

APPLY_COMMON_POLICIES()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
#set(CMAKE_AUTOUIC ON)
#set(CMAKE_AUTORCC ON)

if(MSVC)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY AUTOGEN_TARGETS_FOLDER "Generated")

### COMPILATION OPTIONS MANAGEMENT ####################################################################################

# doc and translations options

option(DIGIKAMSC_CHECKOUT_PO             "Checkout application translations files from git repositories (default=OFF)"            OFF)
option(DIGIKAMSC_CHECKOUT_DOC            "Checkout documentation translations files from git repositories (default=OFF)"          OFF)
option(DIGIKAMSC_COMPILE_PO              "Build translations files (default=ON)"                                                  ON)
option(DIGIKAMSC_COMPILE_DOC             "Build handbook files (default=ON)"                                                      ON)
option(DIGIKAMSC_COMPILE_DIGIKAM         "Build digiKam core (default=ON)"                                                        ON)

#######################################################################################################################

if(DIGIKAMSC_CHECKOUT_PO OR DIGIKAMSC_CHECKOUT_DOC)

    find_package(Ruby)
    find_package(Subversion)

    if(RUBY_EXECUTABLE AND Subversion_FOUND)

        if(DIGIKAMSC_CHECKOUT_PO)

            message(STATUS "Extract application translation files from git repositories. Please wait, it can take a while...")

            execute_process(COMMAND ${RUBY_EXECUTABLE} "${CMAKE_SOURCE_DIR}/project/release/fetch_l10n_po.rb"
                            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")

            message(STATUS "Application translation files extraction done.")

        endif()

        if(DIGIKAMSC_CHECKOUT_DOC)

            message(STATUS "Extract documentation translation files from git repositories. Please wait, it can take a while...")
            message(STATUS "NOTE: (u) want mean uncomplete translations files, which will be removed from compilation.")

            execute_process(COMMAND ${RUBY_EXECUTABLE} "${CMAKE_SOURCE_DIR}/project/release/fetch_l10n_doc.rb"
                            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")

            message(STATUS "Documentation translation files extraction done.")

        endif()

    else()

        message(STATUS "Could not find Ruby or Subversion to extract translation files")

    endif()

endif()

if(DIGIKAMSC_COMPILE_PO AND NOT EXISTS ${CMAKE_SOURCE_DIR}/po/)

    message(STATUS "Application translations directory is missing. Compilation of application translations is disabled...")

    if(NOT DIGIKAMSC_CHECKOUT_PO)
        message(STATUS "You can use DIGIKAMSC_CHECKOUT_PO option to extract GUI i18n files from git repositories.")
    endif()

    set(DIGIKAMSC_COMPILE_PO OFF)

endif()

if(DIGIKAMSC_COMPILE_DOC AND NOT EXISTS ${CMAKE_SOURCE_DIR}/doc/)

    message(STATUS "Main one documentation directory is missing. Compilation of documentation is disabled...")
    set(DIGIKAMSC_COMPILE_DOC OFF)

endif()

if(NOT EXISTS ${CMAKE_SOURCE_DIR}/doc-translated/)

    message(STATUS "Documentation translations directory is missing.")
    message(STATUS "You can use DIGIKAMSC_CHECKOUT_DOC option to extract doc i18n files from git repositories.")

endif()

if(DIGIKAMSC_COMPILE_PO OR DIGIKAMSC_COMPILE_DOC)
    set_property(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)
endif()

if(BUILD_TESTING)
    include(CTest)
endif()

######################################################################################################################

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Top level compilation configuration for ${PROJECT_NAME}")
message(STATUS "")

if(DIGIKAMSC_COMPILE_DIGIKAM)
    if(NOT EXISTS ${CMAKE_SOURCE_DIR}/core)
        message(STATUS "${PROJECT_NAME} will be compiled....................... NO (source code not available)")
        set (DIGIKAMSC_COMPILE_DIGIKAM OFF)
    else()
        message(STATUS "${PROJECT_NAME} will be compiled....................... YES")
    endif()
else()
    message(STATUS     "${PROJECT_NAME} will be compiled....................... NO")
endif()

if(DIGIKAMSC_CHECKOUT_PO)
    message(STATUS "Extract application translations files......... YES")
else()
    message(STATUS "Extract application translations files......... NO")
endif()

if(DIGIKAMSC_CHECKOUT_DOC)
    message(STATUS "Extract documentation translations files....... YES")
else()
    message(STATUS "Extract documentation translations files....... NO")
endif()

if(DIGIKAMSC_COMPILE_PO)
    message(STATUS "Translations will be compiled.................. YES")
else()
    message(STATUS "Translations will be compiled.................. NO")
endif()

if(DIGIKAMSC_COMPILE_DOC)
    message(STATUS "Handbooks will be compiled..................... YES")
else()
    message(STATUS "Handbooks will be compiled..................... NO")
endif()

if(BUILD_TESTING)
    message(STATUS "Tests code will be compiled.................... YES")
else()
    message(STATUS "Tests code will be compiled.................... NO")
endif()

######################################################################################################################

if(DIGIKAMSC_COMPILE_DIGIKAM)
    add_subdirectory(core)
endif()

if(DIGIKAMSC_COMPILE_PO OR DIGIKAMSC_COMPILE_DOC)
    find_package(Gettext REQUIRED)
endif()

if(DIGIKAMSC_COMPILE_PO)
    add_subdirectory(po)
endif()

if(DIGIKAMSC_COMPILE_DOC)
    find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS DocTools)
    ECM_OPTIONAL_ADD_SUBDIRECTORY(doc)
    ECM_OPTIONAL_ADD_SUBDIRECTORY(doc-translated)
endif()

=== core/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
# Copyright (c) 2015      by Mohamed_Anwer, <m_dot_anwer at gmx dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

# ==============================================================================

message(STATUS "----------------------------------------------------------------------------------")
message(STATUS "Check dependencies for ${PROJECT_NAME} version ${DIGIKAM_VERSION_STRING}")
message(STATUS "")

set(KF5_MIN_VERSION       "5.5.0")
set(QT_MIN_VERSION        "5.9.0")
set(EXIV2_MIN_VERSION     "0.27.0")
set(OPENCV_MIN_VERSION    "3.3.0")
set(LENSFUN_MIN_VERSION   "0.2.6.0")      # For Lens auto-correction plugin
set(QTAV_MIN_VERSION      "1.12.0")       # For video support.
set(KSANE_MIN_VERSION     "5.5.0")        # For digital scanner support.
set(CALENDAR_MIN_VERSION  "5.5.0")        # Calendar Core dependency for plugin.
set(AKONADI_MIN_VERSION   "4.89.0")       # Akonadi Contact dependency.

cmake_minimum_required(VERSION ${CMAKE_MIN_VERSION})

# ==============================================================================

option(ENABLE_KFILEMETADATASUPPORT       "Build digiKam with KDE files indexer support (default=OFF)"                         OFF)
option(ENABLE_AKONADICONTACTSUPPORT      "Build digiKam with KDE Mail Contacts support (default=OFF)"                         OFF)
option(ENABLE_MEDIAPLAYER                "Build digiKam with Media Player support (default=OFF)"                              OFF)
option(ENABLE_DBUS                       "Build digiKam with DBUS support (default=ON)"                                       ON)
option(ENABLE_APPSTYLES                  "Build digiKam with support for changing the widget application style (default=OFF)" OFF)
option(ENABLE_QWEBENGINE                 "Build digiKam with QWebEngine instead of QWebKit (default=ON)"                      ON)

# Mysql support options (experimental):
option(ENABLE_MYSQLSUPPORT               "Build digiKam with MySQL dabatase support (default=ON)"                             ON)
option(ENABLE_INTERNALMYSQL              "Build digiKam with internal MySQL server executable (default=ON)"                   ON)

# Developer options:
option(ENABLE_DIGIKAM_MODELTEST          "Enable ModelTest on some models for debugging (default=OFF)"                        OFF)

# Packaging options:
if(MINGW)
    option(ENABLE_DRMINGW                "Enable the Dr. MinGW crash handler support for windows (default ON)"                ON)
    option(ENABLE_MINGW_HARDENING_LINKER "Enable DEP (NX), ASLR, and high-entropy ASLR linker flags for MinGW (default ON)"   ON)
endif()

############## Find Packages ###################

find_package(Qt5 ${QT_MIN_VERSION} REQUIRED
             NO_MODULE COMPONENTS
             Core
             Concurrent
             Widgets
             Gui
             Sql
             Xml
             PrintSupport
             Network
)

if(ENABLE_QWEBENGINE)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS WebEngineWidgets)
else()
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS WebKitWidgets)
endif()

find_package(Qt5 ${QT_MIN_VERSION}
             OPTIONAL_COMPONENTS
             DBus
             OpenGL
             XmlPatterns                # For Rajce plugin
)

if(ENABLE_DBUS)
    if(NOT Qt5DBus_FOUND)
        set(ENABLE_DBUS OFF)
    endif()
endif()

# Dependencies For unit tests and CLI test tools

if(BUILD_TESTING)
    find_package(Qt5 ${QT_MIN_VERSION} REQUIRED
                 NO_MODULE COMPONENTS
                 Test
    )

    find_package(Qt5 ${QT_MIN_VERSION}
                 QUIET
                 OPTIONAL_COMPONENTS
                 Qml WebView  # Optional, for 'sialis' O2 library test tool.
    )
endif()

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
             COMPONENTS
             XmlGui
             CoreAddons
             Config
             Service
             WindowSystem
             Solid
             I18n
)

find_package(KF5 ${KF5_MIN_VERSION} QUIET
             OPTIONAL_COMPONENTS
             KIO                    # For Desktop integration (Widgets only).
             IconThemes             # For Desktop integration.
             FileMetaData           # For KDE file indexer support.
             ThreadWeaver           # For Panorama tool.
             NotifyConfig           # KDE desktop application notify configuration.
             Notifications          # KDE desktop notifications integration.
)

find_package(KF5 ${AKONADI_MIN_VERSION} QUIET
             OPTIONAL_COMPONENTS
             AkonadiContact         # For KDE Mail Contacts support.
             Contacts               # API for contacts/address book data.
)

find_package(KF5 ${KSANE_MIN_VERSION} QUIET
             OPTIONAL_COMPONENTS
             Sane                   # For digital scanner support.
)

find_package(KF5 ${CALENDAR_MIN_VERSION} QUIET
             OPTIONAL_COMPONENTS
             CalendarCore           # For Calendar tool.
)

if ("${KF5CalendarCore_VERSION}" VERSION_GREATER 5.6.40)
    set(HAVE_KCALENDAR_QDATETIME TRUE)
endif()

if(ENABLE_AKONADICONTACTSUPPORT AND (NOT KF5AkonadiContact_FOUND OR NOT KF5Contacts_FOUND))
    set(ENABLE_AKONADICONTACTSUPPORT OFF)
endif()

if(ENABLE_KFILEMETADATASUPPORT AND NOT KF5FileMetaData_FOUND)
    set(ENABLE_KFILEMETADATASUPPORT OFF)
endif()

# Check if KIO have been compiled with KIOWidgets. digiKam only needs this one.
if(KF5KIO_FOUND)
    get_target_property(KIOWidgets_INCLUDE_DIRS KF5::KIOWidgets
                        INTERFACE_INCLUDE_DIRECTORIES)
    message(STATUS "KF5::KIOWidgets include dirs: ${KIOWidgets_INCLUDE_DIRS}")

    if(NOT KIOWidgets_INCLUDE_DIRS)
        message(STATUS "KF5::KIOWidgets not available in shared KIO library. KIO support disabled.")
        set(KF5KIO_FOUND FALSE)
    endif()
endif()

# ==============================================================================
# Dependencies Rules

# mandatory

DETECT_JPEG()
set(DIGIKAM_LIBJPEG_DIR libjpeg/${JPEG_LIB_VERSION})
message(STATUS "Using libjpeg sub-directory: ${DIGIKAM_LIBJPEG_DIR}")

find_package(TIFF)
find_package(PNG)
find_package(Boost)
find_package(LCMS2)
find_package(EXPAT)    # For DNGWriter: XMP SDK need Expat library to compile.
find_package(Threads)  # For DNGWriter and LibRaw which needs native threads support.
find_package(X265)     # For HEIF encoding support.

if(NOT X265_FOUND)
    set(X265_LIBRARIES "")
endif()

find_package(exiv2 REQUIRED)

set_package_properties("exiv2"     PROPERTIES
                       DESCRIPTION "Required to build digiKam"
                       URL         "https://www.exiv2.org"
                       TYPE        RECOMMENDED
                       PURPOSE     "Library to manage image metadata"
)

if("${exiv2_VERSION}" VERSION_LESS ${EXIV2_MIN_VERSION})
    message(FATAL_ERROR "Exiv2 version is too old (${exiv2_VERSION})! Minimal version required:${EXIV2_MIN_VERSION}.")
endif()

# -- check Media player --------------------------------------------------------

find_package(FFmpeg COMPONENTS AVCODEC AVDEVICE AVFILTER AVFORMAT AVUTIL SWSCALE)
find_package(QtAV)

if(ENABLE_MEDIAPLAYER)

    if(${AVCODEC_FOUND} AND ${AVDEVICE_FOUND} AND ${AVFILTER_FOUND} AND ${AVFORMAT_FOUND} AND ${AVUTIL_FOUND} AND ${SWSCALE_FOUND})

        include_directories(${FFMPEG_INCLUDE_DIRS})

    else()

        set(ENABLE_MEDIAPLAYER OFF)
        set(FFMPEG_FOUND OFF)
        message(STATUS "ENABLE_MEDIAPLAYER option is enabled but FFMpeg cannot be found. Media player support is disabled.")

    endif()

    if(NOT ${QtAV_FOUND} OR "${QTAV_VERSION_STRING}" VERSION_LESS ${QTAV_MIN_VERSION})

        set(ENABLE_MEDIAPLAYER OFF)
        set(QtAV_FOUND OFF)
        message(STATUS "ENABLE_MEDIAPLAYER option is enabled but QtAV cannot be found. Media player support is disabled.")

    else()

        include_directories(${QTAV_INCLUDE_DIRS})

    endif()

    if (${QtAV_FOUND} AND ${FFMPEG_FOUND})

        message(STATUS "Media player support is enabled.")

    endif()

endif()


# -- check OpenCV --------------------------------------------------------------

DETECT_OPENCV(${OPENCV_MIN_VERSION} core objdetect imgproc imgcodecs dnn flann)

if(${OpenCV_FOUND})
    if(${OpenCV_VERSION} VERSION_LESS ${OPENCV_MIN_VERSION})
        message(STATUS "OpenCV < ${OPENCV_MIN_VERSION} have been found. Please use a more recent version.")
        set(OpenCV_FOUND FALSE)
    endif()
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/app/utils/digikam_opencv.h.cmake.in
               ${CMAKE_CURRENT_BINARY_DIR}/app/utils/digikam_opencv.h)

# -- optionals -----------------------------------------------------------------

find_package(FLEX)                                 # For Panorama tool.
find_package(BISON)                                # For Panorama tool.

find_package(LibXslt)                              # For HTMLGallery tool.
find_package(LibXml2)                              # For HTMLGallery tool.

find_package(Marble)                               # For geolocation support.

find_package(PkgConfig)
find_package(Jasper)                               # For JPEG 2000 support.
find_package(Eigen3)                               # For Refocus tool.

# -- ImageMagick rules --------------------------------------------------------

find_package(ImageMagick COMPONENTS Magick++ MagickCore)

if(ImageMagick_Magick++_FOUND)
    add_definitions(${ImageMagick_Magick++_DEFINITIONS})
endif()

# -- X11 rules ----------------------------------------------------------------

# For Monitor Profiles management with LCMS
find_package(X11)

if(X11_FOUND)
    find_package(Qt5 ${QT_MIN_VERSION} NO_MODULE COMPONENTS X11Extras)
    set(HAVE_X11 TRUE)
else()
    set(HAVE_X11 FALSE)
endif()

# -- OpenGL rules -------------------------------------------------------------

if(POLICY CMP0072)
    # Prefers Legacy OpenGL by default when available introduced in CMake version 3.11
    # Details: https://cmake.org/cmake/help/git-stage/policy/CMP0072.html
    cmake_policy(SET CMP0072 OLD)
endif()

find_package(OpenGL)                               # For Presentation tool.

message(STATUS "OpenGL found;               ${OPENGL_FOUND}")
message(STATUS "OpenGL GLU extension found; ${OPENGL_GLU_FOUND}")
message(STATUS "OpenGL Qt5 found;           ${Qt5OpenGL_FOUND}")

# decide if Presentation tool can be built with OpenGL
if(OPENGL_FOUND AND OPENGL_GLU_FOUND AND Qt5OpenGL_FOUND)
    set(HAVE_OPENGL TRUE)
elseif()
    set(HAVE_OPENGL FALSE)
endif()

# -- Windows rules ------------------------------------------------------------

# For LibRaw
if(WIN32)
    find_library(WSOCK32_LIBRARY wsock32)
    find_library(WS2_32_LIBRARY ws2_32)
endif()

if(MINGW)

    # NOTE: inspired from https://phabricator.kde.org/T3917
    if(ENABLE_MINGW_HARDENING_LINKER)

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--dynamicbase -Wl,--nxcompat -Wl,--disable-auto-image-base")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--dynamicbase -Wl,--nxcompat -Wl,--disable-auto-image-base")
        set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--dynamicbase -Wl,--nxcompat -Wl,--disable-auto-image-base")

        if ("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")

            # Enable high-entropy ASLR for 64-bit
            # The image base has to be >4GB for HEASLR to be enabled.
            # The values used here are kind of arbitrary.
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--high-entropy-va -Wl,--image-base,0x140000000")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--high-entropy-va -Wl,--image-base,0x180000000")

=== core/showfoto/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

# We need to include the setup dir for showfoto BEFORE the other include dirs,
# otherwise the one from the "utilities" dir will be used
include_directories(BEFORE
                    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar
                    ${CMAKE_CURRENT_SOURCE_DIR}/setup
                    ${CMAKE_CURRENT_SOURCE_DIR}/main
)

set(showfoto_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetuptooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupmisc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupmetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupraw.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetupplugins.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setup/showfotosetup.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoiteminfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoimagemodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotothumbnailmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotofiltermodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotodragdrophandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotokineticscroller.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotoitemsortsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotocoordinatesoverlay.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/itemviewshowfotodelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotodelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfototooltipfiller.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotocategorizedview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thumbbar/showfotothumbnailbar.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfotosettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/main.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_setup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_config.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfoto_import.cpp
)

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../data/icons/apps/*-apps-showfoto.png")
ecm_add_app_icon(showfoto_SRCS ICONS ${ICONS_SRCS})

add_executable(showfoto ${showfoto_SRCS})

add_dependencies(showfoto digikam-gitversion)

# To fill plist XML file for OSX #####################################################

set(MACOSX_APP_NAME_STRING             "showfoto")
set(MACOSX_APP_DESCRIPTION             "Stand alone Photo Editor based on digiKam Image Editor")
set(MACOSX_BUNDLE_LONG_VERSION_STRING  ${DIGIKAM_VERSION_STRING})
set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${DIGIKAM_VERSION_SHORT})
set(MACOSX_BUNDLE_BUNDLE_VERSION       ${DIGIKAM_VERSION_STRING})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/templates/Info.plist.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
set_target_properties(showfoto PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)

target_link_libraries(showfoto

                      PUBLIC

                      Qt5::Core
                      Qt5::Gui
                      Qt5::Xml
                      Qt5::Widgets

                      KF5::XmlGui
                      KF5::I18n
                      KF5::ConfigCore
                      KF5::Service

                      digikamcore
)

if(KF5Notifications_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          KF5::Notifications
    )

endif()

if(KF5NotifyConfig_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          KF5::NotifyConfig
    )

endif()

if(ImageMagick_Magick++_FOUND)

    target_link_libraries(showfoto
                          PUBLIC
                          ${ImageMagick_LIBRARIES}
    )

endif()

if(NOT WIN32)

    # To link under Solaris (see bug #274484)
    target_link_libraries(showfoto
                          PUBLIC
                          ${MATH_LIBRARY}
    )

endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

    target_link_libraries(showfoto
                          PUBLIC
                          ${KVM_LIBRARY}
    )

endif()

if(APPLE)

    target_link_libraries(showfoto
                          PUBLIC
                          /System/Library/Frameworks/AppKit.framework
    )

endif()

install(TARGETS  showfoto                                                      ${INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.showfoto.desktop     DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/org.kde.showfoto.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES    ${CMAKE_CURRENT_SOURCE_DIR}/main/showfotoui5.rc               DESTINATION ${KXMLGUI_INSTALL_DIR}/showfoto)

=== core/tests/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

# enabling for everything although only required by DImg.
kde_enable_exceptions()

# -------------------------------------------------------------------------------
# Unit-tests common dependencies

if(ENABLE_QWEBENGINE)

    set(_extra_deps ${_extra_deps} Qt5::WebEngineWidgets)

else()

    set(_extra_deps ${_extra_deps} Qt5::WebKitWidgets)

endif()

if(ENABLE_DBUS)

    set(_extra_deps ${_extra_deps} Qt5::DBus)

endif()

if(KF5Notifications_FOUND)

    set(_extra_deps ${_extra_deps} KF5::Notifications)

endif()

if(Gphoto2_FOUND)

    set(_extra_deps ${_extra_deps} ${GPHOTO2_LIBRARIES})

endif()

if(ImageMagick_Magick++_FOUND)

    set(_extra_deps ${_extra_deps} ${ImageMagick_LIBRARIES})

endif()

if(LensFun_FOUND)

    set(_extra_deps ${_extra_deps} ${LENSFUN_LIBRARIES})

endif()

if(Jasper_FOUND)

    set(_extra_deps ${_extra_deps} ${JASPER_LIBRARIES})

endif()

if(ENABLE_MEDIAPLAYER)

    set(_extra_deps ${_extra_deps} ${QTAV_LIBRARIES})

endif()

if(WIN32)

    set(_extra_deps ${_extra_deps} ws2_32)

endif()

if(NOT WIN32)

    # To link under Solaris (see bug #274484)
    set(_extra_deps ${_extra_deps} ${MATH_LIBRARY})

endif()

if(CMAKE_SYSTEM_NAME STREQUAL FreeBSD)

    set(_extra_deps ${_extra_deps} ${KVM_LIBRARY})

endif()

if(APPLE)

    set(_extra_deps ${_extra_deps} /System/Library/Frameworks/AppKit.framework)

endif()

set(COMMON_TEST_LINK Qt5::Core
                     Qt5::Gui
                     Qt5::Xml
                     Qt5::Widgets
                     Qt5::Concurrent
                     Qt5::Test
                     Qt5::Sql

                     KF5::XmlGui
                     KF5::I18n
                     KF5::ConfigCore
                     KF5::Service
                     KF5::Solid

                     ${OPENMP_LDFLAGS}
                     ${JPEG_LIBRARIES}
                     ${LCMS2_LIBRARIES}
                     ${EXPAT_LIBRARY}
                     ${CMAKE_THREAD_LIBS_INIT}

                     opencv_core
                     opencv_objdetect
                     opencv_imgproc
                     opencv_imgcodecs
                     opencv_dnn
                     opencv_flann

                     ${_extra_deps}
)

# -------------------------------------------------------------------------------
# Common static library for uint-tests based on ModelTest

include_directories(modeltest)

add_library(libmodeltest STATIC
            modeltest/modeltest.cpp
)

target_link_libraries(libmodeltest
                      PRIVATE
                      Qt5::Core
                      Qt5::Test
)

# -------------------------------------------------------------------------------
# Unit-tests and CLI tools

add_subdirectory(advancedrename)
add_subdirectory(albummodel)                    # Unit-test based on ModelTest
add_subdirectory(database)                      # Some unit-tests based on ModelTest
add_subdirectory(dialogs)
add_subdirectory(dimg)
add_subdirectory(dngwriter)
add_subdirectory(dplugins)
add_subdirectory(facesengine)
add_subdirectory(fileio)
add_subdirectory(filters)
add_subdirectory(imgqsort)
add_subdirectory(iojobs)
add_subdirectory(mediaserver)
add_subdirectory(mediawiki)
add_subdirectory(metadataengine)
add_subdirectory(multithreading)
add_subdirectory(rawengine)
add_subdirectory(timestampupdate)
add_subdirectory(webservices)
add_subdirectory(widgets)

if(Marble_FOUND)
    add_subdirectory(geolocation)               # Some unit-tests based on ModelTest
endif()

if(FLEX_FOUND AND BISON_FOUND AND KF5ThreadWeaver_FOUND)
    add_subdirectory(panorama)
endif()

if(ENABLE_MEDIAPLAYER)
    add_subdirectory(video)
endif()

if(KF5KIO_FOUND)
    add_subdirectory(vkontakte)
endif()

=== core/libs/dimg/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

kde_enable_exceptions()

# Boost uses operator names (and, not, ...)
string(REPLACE "-fno-operator-names" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

set(libdimg_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_bitsops.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_colors.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_copy.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_data.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_fileio.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_metadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_props.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_qimage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_qpixmap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_scale.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dimg_transform.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/color/dcolor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/color/dcolorcomposer.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/history/dimagehistory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/history/filteraction.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/history/historyimageid.cpp
)

set(libdimgfilters_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dimgbuiltinfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dimgthreadedfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dimgthreadedanalyser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dimgfiltermanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dimgfiltergenerator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/dpixelsaliasfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/filteractionfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/randomnumbergenerator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/raw/rawprocessingfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/raw/drawdecoding.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/borderfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/bordersettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/bordercontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/texturecontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/texturefilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/decorate/texturesettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/film/filmfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/blurfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/blurfxfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/colorfxfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/colorfxsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/distortionfxfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/charcoalfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/embossfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/filmgrainfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/filmgrainsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/invertfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/oilpaintfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/fx/raindropfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/auto/autolevelsfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/auto/autoexpofilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/auto/equalizefilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/auto/stretchfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/auto/normalizefilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/cb/cbfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/cb/cbsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bcg/bcgfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bcg/bcgsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bcg/bcgcontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/bwsepiafilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/bwsepiasettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/tonalityfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/infraredfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/mixerfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/bw/mixersettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hsl/hslfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hsl/hslsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hsl/hspreviewwidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/blackframeparser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/blackframelistview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/blackframelistviewitem.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/blackframetooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/hotpixelprops.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/hotpixelfixer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/hotpixelsweights.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/hotpixelsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/hotpixels/hotpixelcontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/iccmanager.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/iccprofile.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/iccprofilesettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/icctransform.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/icctransformfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/iccsettingscontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/iccsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/icc/digikam-lcms.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lc/localcontrastfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lc/localcontrastsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lc/localcontrastcontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/nr/nrfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/nr/nrestimate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/nr/nrsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/sharp/sharpenfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/sharp/unsharpmaskfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/sharp/sharpsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/imagelevels.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/levelsfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/imagehistogram.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/histogrambox.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/histogramwidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/levels/histogrampainter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/curvescontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/imagecurves.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/curvesfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/curvessettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/curveswidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/curves/curvesbox.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/wb/wbcontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/wb/wbfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/wb/wbsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/transform/freerotationfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/transform/freerotationsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/transform/shearfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/transform/autocrop.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/greycstoration/greycstorationfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/greycstoration/greycstorationsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/antivignettingfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/antivignettingsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensdistortionfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensdistortionpixelaccess.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/redeye/redeyecorrectionfilter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/redeye/redeyecorrectionsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/redeye/redeyecorrectioncontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalitycontainer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalitysettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalityparser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalityparser_blur.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalityparser_exposure.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalityparser_noise.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/filters/imgqsort/imagequalityparser_compression.cpp
)

# ==================================================================================================
# get the gcc version

# CImg.h version 1.2.8 do not compile fine with gcc 4.3.x
# See bug #163118: digikam-0.9.4_beta5 compilation hangs with gcc 4.3
# Using -fno-tree-pre is work around this problem.

# TODO is this hack anymore required?
if(CMAKE_COMPILER_IS_GNUCXX)

    exec_program(${CMAKE_CXX_COMPILER} ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion OUTPUT_VARIABLE GCC_VERSION)

    if (${GCC_VERSION} VERSION_LESS "4.3.0")
        message(STATUS "Adjusting compilation flags for GCC version (${GCC_VERSION} )")
        add_definitions(-fno-tree-pre)
    endif()

endif()


if(Lqr-1_FOUND)

    set(libdimgfilters_SRCS
        ${libdimgfilters_SRCS}
        filters/transform/contentawarefilter.cpp
    )

    include_directories(${LQR-1_INCLUDE_DIRS})

endif()

if(LensFun_FOUND)

    set(libdimgfilters_SRCS
        ${libdimgfilters_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensfunfilter.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensfuncameraselector.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensfuniface.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/lens/lensfunsettings.cpp
    )

    include_directories(${LENSFUN_INCLUDE_DIRS})

endif()

if(Eigen3_FOUND)

    set(libdimgfilters_SRCS
        ${libdimgfilters_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/sharp/refocusfilter.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/filters/sharp/refocusmatrix.cpp
    )

    include_directories(${EIGEN3_INCLUDE_DIR})

endif()

set(libdimgloaders_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/loaders/dimgloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/loaders/jpegsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/loaders/pngsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/loaders/tiffsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/loaders/pgfsettings.cpp
)

# JPEG2000 support

if(Jasper_FOUND)

    set(libdimgloaders_SRCS
        ${libdimgloaders_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/loaders/jp2ksettings.cpp
    )

endif()

# HEIF support
if(X265_FOUND)

    set(libdimgloaders_SRCS
        ${libdimgloaders_SRCS}
        ${CMAKE_CURRENT_SOURCE_DIR}/loaders/heifsettings.cpp
    )

endif()

include_directories(
    $<TARGET_PROPERTY:Qt5::Concurrent,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:Qt5::Xml,INTERFACE_INCLUDE_DIRECTORIES>

    $<TARGET_PROPERTY:KF5::ConfigCore,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF5::I18n,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:KF5::WidgetsAddons,INTERFACE_INCLUDE_DIRECTORIES>
)

if(X11_FOUND)

    include_directories($<TARGET_PROPERTY:Qt5::X11Extras,INTERFACE_INCLUDE_DIRECTORIES>)

endif()

# Don't process automoc on LibCImg headers

file(GLOB_RECURSE cimg_headers ${CMAKE_CURRENT_SOURCE_DIR}/filters/greycstoration/cimg/*.h)

foreach(_file ${cimg_headers})

    set_property(SOURCE ${_file} PROPERTY SKIP_AUTOMOC ON)

endforeach()

# Used by digikamcore
add_library(core_dimg_obj OBJECT
            ${libdimgloaders_SRCS}
            ${libdimgfilters_SRCS}
            ${libdimg_SRCS}
)

target_compile_definitions(core_dimg_obj
                           PRIVATE
                           digikamcore_EXPORTS
)

=== core/utilities/lighttable/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

set(liblighttable_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablepreview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttableview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablethumbbar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindow.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindow_config.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindow_setup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindow_tools.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindow_import.cpp
)

include_directories($<TARGET_PROPERTY:Qt5::PrintSupport,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Gui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Sql,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Network,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Xml,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Network,INTERFACE_INCLUDE_DIRECTORIES>

                    $<TARGET_PROPERTY:KF5::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::Solid,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::Service,INTERFACE_INCLUDE_DIRECTORIES>
)

if(Gphoto2_FOUND)
    include_directories(${GPHOTO2_INCLUDE_DIRS})
endif()

# Used by digikamgui
add_library(gui_lighttable_obj OBJECT ${liblighttable_SRCS})

target_compile_definitions(gui_lighttable_obj
                           PRIVATE
                           digikamgui_EXPORTS
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/lighttablewindowui5.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/digikam)

=== core/utilities/setup/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
# Copyright (c) 2015      by Veaceslav Munteanu, <veaceslav dot munteanu90 at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

APPLY_COMMON_POLICIES()

include_directories($<TARGET_PROPERTY:Qt5::Sql,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Widgets,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>

                    $<TARGET_PROPERTY:KF5::I18n,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::WidgetsAddons,INTERFACE_INCLUDE_DIRECTORIES>
                    $<TARGET_PROPERTY:KF5::XmlGui,INTERFACE_INCLUDE_DIRECTORIES>
)


set(libsetupshowfoto_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/editor/setupeditoriface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/editor/setupiofiles.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/editor/setupraw.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setupicc.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/system/systemsettingswidget.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/system/systemsettings.cpp
)

# Used by digikamcore
add_library(core_setupcommon_obj OBJECT  ${libsetupshowfoto_SRCS})

target_compile_definitions(core_setupcommon_obj
                           PRIVATE
                           digikamcore_EXPORTS
)

# ---------------------------------------------------------------------

set(libsetup_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/setup.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setuptooltip.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setuptemplate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setupmisc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setupplugins.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setuplighttable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setupdatabase.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setupimagequalitysorter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/setuputils.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/editor/setupeditor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/editor/setupversioning.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/album/setupalbumview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/album/setupcategory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/album/setupmime.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/metadata/setupmetadata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/metadata/advancedmetadatatab.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/metadata/namespacelistview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/metadata/namespaceeditdlg.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/collections/setupcollections.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collections/setupcollectionview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collections/dwitemdelegate.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collections/dwitemdelegate_p.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/collections/dwitemdelegatepool.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/camera/importfilterdlg.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/camera/setupcamera.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/camera/cameraselection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/camera/cameralist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/camera/cameratype.cpp
)

# Used by digikamgui
add_library(gui_setup_obj OBJECT ${libsetup_SRCS})

target_compile_definitions(gui_setup_obj
                           PRIVATE
                           digikamgui_EXPORTS
)

=== core/dplugins/bqm/decorate/CMakeLists.txt ===
#
# Copyright (c) 2015-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(border)
add_subdirectory(watermark)
add_subdirectory(texture)

=== core/dplugins/bqm/enhance/CMakeLists.txt ===
#
# Copyright (c) 2015-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

add_subdirectory(antivignetting)
add_subdirectory(blur)
add_subdirectory(localcontrast)
add_subdirectory(noisereduction)
add_subdirectory(redeyecorrection)
add_subdirectory(restoration)
add_subdirectory(sharpen)
add_subdirectory(hotpixels)

if(LensFun_FOUND)
    add_subdirectory(lensautofix)
endif()

=== core/dplugins/generic/webservices/CMakeLists.txt ===
#
# Copyright (c) 2010-2020 by Gilles Caulier, <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

if(ENABLE_QWEBENGINE)
    include_directories($<TARGET_PROPERTY:Qt5::WebEngineWidgets,INTERFACE_INCLUDE_DIRECTORIES>)
    SET(QWEB_BACKEND Qt5::WebEngineWidgets)
else()
    include_directories($<TARGET_PROPERTY:Qt5::WebKitWidgets,INTERFACE_INCLUDE_DIRECTORIES>)
    SET(QWEB_BACKEND Qt5::WebKitWidgets)
endif()

add_subdirectory(box)
add_subdirectory(dropbox)
add_subdirectory(facebook)
add_subdirectory(filecopy)
add_subdirectory(flickr)
add_subdirectory(google)
add_subdirectory(imgur)
add_subdirectory(imageshack)
add_subdirectory(ipfs)
add_subdirectory(mediawiki)
add_subdirectory(onedrive)
add_subdirectory(pinterest)
add_subdirectory(piwigo)

if(Qt5XmlPatterns_FOUND)
    add_subdirectory(rajce)
endif()

add_subdirectory(smugmug)
add_subdirectory(twitter)
add_subdirectory(yandexfotki)

if(KF5KIO_FOUND)
    add_subdirectory(vkontakte)
    add_subdirectory(filetransfer)

#    Not yet finalized
#    add_subdirectory(debianscreenshots)
endif()

# Not yet finalized
#add_subdirectory(unified)

=== project/bundles/3rdparty/ext_boost/CMakeLists.txt ===
# Script to build Boost for digiKam bundle.
#
# Copyright (c) 2015-2020 by Gilles Caulier  <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.
#

SET(PREFIX_ext_boost "${EXTPREFIX}")

ExternalProject_Add( ext_boost
    DOWNLOAD_DIR ${EXTERNALS_DOWNLOAD_DIR}
    URL http://downloads.sourceforge.net/project/boost/boost/1.73.0/boost_1_73_0.tar.bz2
    URL_MD5 9273c8c4576423562bbe84574b07b2bd
    CONFIGURE_COMMAND <SOURCE_DIR>/bootstrap.sh --prefix=${PREFIX_ext_boost} --with-libraries=system
    BUILD_COMMAND <SOURCE_DIR>/b2 install
    INSTALL_COMMAND ""
    INSTALL_DIR ${PREFIX_ext_boost}

    UPDATE_COMMAND ""
    ALWAYS 0
    BUILD_IN_SOURCE 1
)

=== project/bundles/3rdparty/ext_cmake/CMakeLists.txt ===
# Script to build Cmake.
#
# Copyright (c) 2015-2020 by Gilles Caulier  <caulier dot gilles at gmail dot com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.
#

SET(EXTPREFIX_cmake "${EXTPREFIX}")

ExternalProject_Add(ext_cmake

    GIT_REPOSITORY https://gitlab.kitware.com/cmake/cmake.git
    GIT_TAG v3.17.3

    INSTALL_DIR ${EXTPREFIX_cmake}

    CONFIGURE_COMMAND cd <SOURCE_DIR> && ./bootstrap --prefix=${EXTPREFIX_cmake}

    BUILD_COMMAND ${MAKE}

    UPDATE_COMMAND ""
    BUILD_IN_SOURCE 1
    ALWAYS 0
)

=== debian/changelog ===
digikam (4:7.1.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [05f5ebe] Add build-dep for libavdevice-dev to get working video support.
    Closes: #974889, #977297

 -- Steve M. Robbins <smr@debian.org>  Wed, 06 Jan 2021 20:35:40 -0600

digikam (4:7.1.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [2090afd] New upstream version 7.1.0.  Closes: #968494, #973656, #972612.
  * New upstream reported that following bugs are fixed: #721826, #731619.
  * [a5263e7] Refresh overrides.

 -- Steve M. Robbins <smr@debian.org>  Sun, 08 Nov 2020 23:16:09 -0600

digikam (4:7.0.0-1) experimental; urgency=medium

  [ Steve Robbins ]
  * [74b256e] New upstream version 7.0.0

 -- Steve M. Robbins <smr@debian.org>  Mon, 17 Aug 2020 21:56:17 -0500

digikam (4:7.0.0~beta2+dfsg-1) experimental; urgency=medium

  [ Steve Robbins ]
  * New upstream version 7.0.0-beta2

 -- Steve M. Robbins <smr@debian.org>  Mon, 17 Feb 2020 22:33:04 -0600

=== debian/control ===
Source: digikam
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>,
           Fathi Boudra <fabo@debian.org>,
           Steve M. Robbins <smr@debian.org>
Section: graphics
Priority: optional
Build-Depends: appstream,
               bison,
               cmake (>= 3.0.0),
               debhelper-compat (= 12),
               extra-cmake-modules,
               flex,
               gphoto2,
               help2man,
# FFMPEG libraries
               libavcodec-dev, libavfilter-dev, libavformat-dev, libavutil-dev, libswscale-dev,
               libavdevice-dev,
               libboost-graph-dev,
               libeigen3-dev (>= 3.1.2),
               libexiv2-dev (>= 0.27),
               libexpat1-dev | libexpat-dev,
               libgphoto2-dev,
               libjpeg-dev,
               libkf5akonadicontact-dev,
               libkf5calendarcore-dev,
               libkf5doctools-dev,
               libkf5filemetadata-dev,
               libkf5mediawiki-dev,
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5sane-dev,
               libkf5threadweaver-dev,
               liblcms2-dev,
               liblensfun-dev,
               liblqr-1-0-dev,
               libmagick++-dev,
               libmarble-dev,
               libopencv-dev (>= 3.1.0),
               libpng-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5x11extras5-dev,
               libqt5xmlpatterns5-dev,
               libqtav-dev (>= 1.13),
               libtiff-dev,
               libusb-1.0-0-dev [linux-any],
               libx265-dev,
               libxslt1-dev,
               libxml2-dev,
               pkg-config,
               pkg-kde-tools (>= 0.15.21),
               qtbase5-dev (>= 5.4.0),
               qtbase5-dev-tools (>= 5.4.0),
               qtmultimedia5-dev,
               qtwebengine5-dev
Build-Conflicts: libgraphicsmagick1-dev,
                 libboost1.62-dev (<< 1.62.0+dfsg-4)
Standards-Version: 4.1.0
Vcs-Browser: https://salsa.debian.org/debian/digikam
Vcs-Git: https://salsa.debian.org/debian/digikam.git
Homepage: http://www.digikam.org

Package: digikam-private-libs
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: private libraries for digiKam plugins
 This package contains private libraries to be used by digikam.
 .
 This has no use for anything else than digikam, since the libraries are
 installed in a private library path.

Package: digikam
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         digikam-private-libs (= ${binary:Version}),
         libqt5sql5-sqlite,
         libqt5sql5-mysql,
         digikam-data (= ${source:Version})
Recommends: www-browser,
            ffmpegthumbs
Suggests: digikam-doc,
          systemsettings
Conflicts: ${digikam:Conflicts}
Description: digital photo management application for KDE
 Digital photo management program designed to import, organize, enhance, search
 and export your digital images to and from your computer.
 .
 It provides a simple interface which makes importing and organizing digital
 photographs a "snap". digiKam enables you to manage large numbers of
 digital photographs in albums and to organize these photographs for easy
 retrieval using tags (keywords), captions, collections, dates, geolocation
 and searches. It has many features for viewing, organizing, processing and
 sharing your images. Thus, digiKam is a formidable digital asset management
 (DAM) software including powerful image editing functions.
 .
 An easy-to-use camera interface is provided, that will connect to your
 digital camera and download photographs directly into digiKam albums.
 More than 1000 digital cameras are supported by the gphoto2 library.
 Of course, any media or card reader supported by your operating system
 will interface with digiKam.
 .
 digiKam incorporates a fast Image Editor with many image editing tools.
 You can use the Image Editor to view your photographs, comment and rate
 them, correct, enhance and alter them. The editing power can be easily
 extended by a set of plugins, the KDE Image Plugins Interface (manual)
 .
 While digiKam remains easy to use, it provides professional level features
 by the dozens. It is fully 16 bit enabled including all available plugins,
 supports RAW format conversion through libraw, DNG export and ICC color
 management work flow.

Package: showfoto
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         digikam-data (= ${source:Version}),
         digikam-private-libs (= ${binary:Version})
Recommends: dolphin
Description: image viewer/editor for KDE
 showFoto is the standalone image editor of the digiKam project.
 .
 It runs without digiKam images database support, but provides all Image Editor
 functions.

Package: digikam-data
Architecture: all
Depends: ${misc:Depends},
         opencv-data
Conflicts: ${digikam:Conflicts}
Description: digiKam architecture-independant data
 Contains the significant amount of architecture-independent data that is
 shipped with digiKam.
 .
 It has been placed in an architecture all file to reduce space on the
 archives, rather than one copy for each architecture.
